%define name fluxbb
%define version 1.5.5
%define release 0.beta11
%define httpuser apache

%if 0%{?fedora} >= 11 || 0%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: A forum engine
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
License: GPLv2
URL: http://fluxbb.org/
Group: Applications/Internet
Source: http://fluxbb.org/download/releases/%{version}/%{name}-%{version}.tar.bz2
Source1: french_v1.5.4.zip
Source2: sceditor-wysiwyg_v1.1.zip
Source3: fluxbb-file-uploader_v1.1.0.zip
Source4: httpd.conf

Patch0: fluxbb-1.5.5-external_login.patch
Patch1: fluxbb-1.5.5-ext_login_locale_fr.patch
Patch2: fluxbb-1.5.5-scedit.patch
Patch3: fluxbb-1.5.5-file_upload.patch
Patch4: fluxbb-1.5.5-proto_emoticon_conflict.patch

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}

Requires: php
Requires: php-mbstring
Requires: httpd
%if %{useselinux}
Requires: %{_sbindir}/semanage
%endif


%description
FluxBB is designed as a lighter, faster alternative to some of the traditional
feature heavy forum applications. It is easy to use and has a proven track
record of stability and security making it an ideal choice of forum for your
website.

%prep
%setup -q -n %{name}-%{version}
unzip %{SOURCE1} -d lang/
unzip %{SOURCE2}
cp -pr FluxBB-SCEditor/files/* ./
rm -rf FluxBB-SCEditor __MACOSX
unzip %{SOURCE3}
rm -f ChangeLog.txt LisezMoi.txt ReadMe.txt
mv upload_install.php upload_installer.php
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
# empty build

%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}/%{_datadir}/%{name}
%{__mkdir_p} %{buildroot}/%{_localstatedir}/lib/%{name}/avatars
%{__mkdir_p} %{buildroot}/%{_localstatedir}/lib/%{name}/uploads
%{__mkdir_p} %{buildroot}/%{_localstatedir}/cache/%{name}
%{__mkdir_p} %{buildroot}/%{_sysconfdir}/httpd/conf.d

%{__cp} -pr ./* %{buildroot}/%{_datadir}/%{name}/
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/{readme.md,COPYING}
%{__rm} -rf %{buildroot}/%{_datadir}/%{name}/cache
%{__mv} %{buildroot}/%{_datadir}/%{name}/img/avatars/* %{buildroot}/%{_localstatedir}/lib/%{name}/avatars/
rmdir %{buildroot}/%{_datadir}/%{name}/img/avatars/
ln -sf %{_localstatedir}/lib/%{name}/avatars/ %{buildroot}/%{_datadir}/%{name}/img/avatars
ln -sf %{_localstatedir}/lib/%{name}/uploads/ %{buildroot}/%{_datadir}/%{name}/img/uploads
touch %{buildroot}/%{_datadir}/%{name}/config.php

# Install apache conf
%{__install} -m 0640 %{SOURCE4} %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%clean
rm -rf %{buildroot}

%post
%if %{useselinux}
(
# New File context
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/cache/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_datadir}/%{name}/config.php.php"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_localstatedir}/lib/%{name}(/.*)?"
# files created by app
restorecon -R %{_data}/%{name}/config.php
restorecon -R %{_localstatedir}/cache/%{name}
restorecon -R %{_localstatedir}/lib/%{name}
) &>/dev/null || :
%endif

%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/cache/%{name}(/.*)?"
    semanage fcontext -d "%{_datadir}/%{name}/config.php"
    semanage fcontext -d "%{_localstatedir}/lib/%{name}(/.*)?"
    ) &>/dev/null || :
fi
%endif


%files
%defattr(-,root,root)
%doc readme.md COPYING
%{_datadir}/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/cache/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/avatars
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/uploads
%{_localstatedir}/lib/%{name}/avatars/index.html
%config(noreplace) %attr(660,root,%{httpuser}) %{_datadir}/%{name}/config.php
%config(noreplace) %attr(660,root,root) %{_sysconfdir}/httpd/conf.d/%{name}.conf

%changelog
* Thu Nov 21 2013 Daniel B. <daniel@firewall-services.com> 1.5.5-1
- First package


